classification
Title: Lazily create dictionaries for plain Python objects
Type: enhancement Stage: resolved
Components: Interpreter Core Versions: Python 3.11
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: Mark.Shannon Nosy List: Mark.Shannon, corona10, josh.r, methane
Priority: normal Keywords: patch

Created on 2021-10-01 11:21 by Mark.Shannon, last changed 2021-10-20 10:54 by Mark.Shannon. This issue is now closed.

Pull Requests
URL Status Linked Edit
PR 28802 closed Mark.Shannon, 2021-10-07 14:33
Messages (6)
msg403010 - (view) Author: Mark Shannon (Mark.Shannon) * (Python committer) Date: 2021-10-01 11:21
A "Normal" Python objects is conceptually just a pair of pointers, one to the class, and one to the dictionary.

With shared keys, the dictionary is redundant as it is no more than a pair of pointers, one to the keys and one to the values.

By adding a pointer to the values to the object, or embedding the values in the object, and fetching the keys via the class, we can avoid creating a dictionary for many objects.

See https://github.com/faster-cpython/ideas/issues/72 for more details.
msg403492 - (view) Author: Josh Rosenberg (josh.r) * (Python triager) Date: 2021-10-08 19:03
Hmm... Key-sharing dictionaries were accepted largely without question because they didn't harm code that broke them (said code gained nothing, but lost nothing either), and provided a significant benefit. Specifically:

1. They imposed no penalty on code that violated the code-style recommendation to initialize all variables consistently in __init__ (code that always ended up using a non-sharing dict). Such classes don't benefit, but neither do they get penalized (just a minor CPU cost to unshare when it realized sharing wouldn't work). 

2. It imposes no penalty for using vars(object)/object.__dict__ when you don't modify the set of keys (so reading or changing values of existing attributes caused no problems).

The initial version of this worsens case #2; you'd have to convert to key-sharing dicts, and possibly to unshared dicts a moment later, if the set of attributes is changed. And when it happens, you'd be paying the cost of the now defunct values pointer storage for the life of each instance (admittedly a small cost).

But the final proposal compounds this, because the penalty for lazy attribute creation (directly, or dynamically by modifying via vars()/__dict__) is now a per-instance cost of n pointers (one for each value).

The CPython codebase rarely uses lazy attribute creation, but AFAIK there is no official recommendation to avoid it (not in PEP 8, not in the official tutorial, not even in PEP 412 which introduced Key-Sharing Dictionaries). Imposing a fairly significant penalty on people who aren't even violating language recommendations, let alone language rules, seems harsh.

I'm not against this initial version (one pointer wasted isn't so bad), but the additional waste in the final version worries me greatly.

Beyond the waste, I'm worried how you'd handle the creation of the first instance of such a class; you'd need to allocate and initialize an instance before you know how many values to tack on to the object. Would the first instance use a real dict during the first __init__ call that it would use to realloc the instance (and size all future instances) at the end of __init__? Or would it be realloc-ing for each and every attribute creation? In either case, threading issues seem like a problem.

Seems like:

1. Even in the ideal case, this only slightly improves memory locality, and only provides a fixed reduction in memory usage per-instance (the dict header and a little allocator round-off waste), not one that scales with number of attributes.

2. Classes that would benefit from this would typically do better to use __slots__ (now that dataclasses.dataclass supports slots=True, encouraging that as a default use case adds little work for class writers to use them)

If the gains are really impressive, might still be worth it. But I'm just worried that we'll make the language penalize people who don't know to avoid lazy attribute creation. And the complexity of this layered:

1. Not-a-dict
2. Key-sharing-dict
3. Regular dict

approach makes me worry it will allow subtle bugs in key-sharing dicts to go unnoticed (because so little code would still use them).
msg403494 - (view) Author: Josh Rosenberg (josh.r) * (Python triager) Date: 2021-10-08 19:09
Hmm... And there's one other issue (that wouldn't affect people until they actually start worrying about memory overhead). Right now, if you want to determine the overhead of an instance, the options are:

1. Has __dict__: sys.getsizeof(obj) + sys.getsizeof(obj.__dict__)
2. Lacks __dict__ (built-ins, slotted classes): sys.getsizeof(obj)

This change would mean even checking if something using this setup has a __dict__ creates one. Without additional introspection support, there's no way to tell the real memory usage of the instance without changing the memory usage (for the worse).
msg403737 - (view) Author: Mark Shannon (Mark.Shannon) * (Python committer) Date: 2021-10-12 14:35
Josh,

I'm not really following the details of what you are saying.

You claim "Key-sharing dictionaries were accepted largely without question because they didn't harm code that broke them".
Is that true? I don't remember it that way. They were accepted because they saved memory and didn't slow things down.

This issue, proposes the same thing: less memory used, no slower or a bit faster.

If you are curious about how the first few instances of a class are handled, it is described here: 
https://github.com/faster-cpython/ideas/issues/72#issuecomment-920117600

Lazy attribute is not an issue here. How well keys are shared across instances depends on the dictionary implementation and was improved by https://github.com/python/cpython/pull/28520


It would be helpful if you could give specific examples where you think this change would use more memory or be slower.
msg403830 - (view) Author: Mark Shannon (Mark.Shannon) * (Python committer) Date: 2021-10-13 13:19
New changeset a8b9350964f43cb648c98c179c8037fbf3ff8a7d by Mark Shannon in branch 'main':
bpo-45340: Don't create object dictionaries unless actually needed (GH-28802)
https://github.com/python/cpython/commit/a8b9350964f43cb648c98c179c8037fbf3ff8a7d
msg404424 - (view) Author: Mark Shannon (Mark.Shannon) * (Python committer) Date: 2021-10-20 10:54
Josh, please reopen if you have more to add.
History
Date User Action Args
2021-10-20 10:54:07Mark.Shannonsetstatus: open -> closed
resolution: fixed
messages: + msg404424

stage: patch review -> resolved
2021-10-13 13:19:42Mark.Shannonsetmessages: + msg403830
2021-10-12 14:35:58Mark.Shannonsetmessages: + msg403737
2021-10-08 19:09:20josh.rsetmessages: + msg403494
2021-10-08 19:03:23josh.rsetnosy: + josh.r
messages: + msg403492
2021-10-07 14:33:29Mark.Shannonsetkeywords: + patch
stage: patch review
pull_requests: + pull_request27125
2021-10-02 14:39:54corona10setnosy: + corona10
2021-10-01 11:21:17Mark.Shannoncreate